diff --git a/bwb_ops.c b/bwb_ops.c
index bb2bb3e..3cfd103 100644
--- a/bwb_ops.c
+++ b/bwb_ops.c
@@ -23,6 +23,11 @@
 
 ****************************************************************/
 
+/*---------------------------------------------------------------*/
+/* NOTE: Modifications marked "JBV" were made by Jon B. Volkoff, */
+/* 11/1995 (eidetics@cerf.net).                                  */
+/*---------------------------------------------------------------*/
+
 #include <stdio.h>
 #include <ctype.h>
 #include <math.h>
@@ -52,6 +57,7 @@ static int op_or( int level, int precision );
 static int op_and( int level, int precision );
 static int op_not( int level, int precision );
 static int op_xor( int level, int precision );
+static int op_negation( int level, int precision ); /* JBV */
 static int op_islevelstr( int level );
 static int op_getprecision( int level );
 static int op_isoperator( int operation );
@@ -76,6 +82,7 @@ static int op_or();
 static int op_and();
 static int op_not();
 static int op_xor();
+static int op_negation(); /* JBV */
 static int op_islevelstr();
 static int op_getprecision();
 static int op_isoperator();
@@ -312,6 +319,10 @@ op_oplevel( level )
             op_exponent( level, precision );
             break;
 
+         case OP_NEGATION: /* JBV */
+            op_negation( level, precision );
+            break;
+
          default:
 #if PROG_ERRORS
             sprintf( bwb_ebuf, "PROGRAMMING ERROR: operator <%d> not (yet) supported.", CURTASK exps[ level ].operation );
@@ -395,8 +406,10 @@ op_add( level, precision )
 #endif
    {
    int error_condition;
+   static bstring b; /* JBV */
 
    error_condition = FALSE;
+   b.rab = FALSE; /* JBV */
 
    switch( precision )
       {
@@ -435,8 +448,15 @@ op_add( level, precision )
             bwb_debug( bwb_ebuf );
 #endif
 
-            str_cat( exp_getsval( &( CURTASK exps[ level - 1 ] ) ), 
-               exp_getsval( &( CURTASK exps[ level + 1 ] ) ) );
+            /* Removed by JBV (incomplete, modifies wrong string variable!) */
+            /* str_cat( exp_getsval( &( CURTASK exps[ level - 1 ] ) ), 
+               exp_getsval( &( CURTASK exps[ level + 1 ] ) ) ); */
+
+            /* Added by JBV */
+            str_btob( &b, exp_getsval( &( CURTASK exps[ level - 1 ] ) ) );
+            str_cat( &b, exp_getsval( &( CURTASK exps[ level + 1 ] ) ) );
+            str_btob( &( CURTASK exps[ level - 1 ].sval ), &b );
+            CURTASK exps[ level - 1 ].operation = CONST_STRING;
 
 #if INTENSIVE_DEBUG
             sprintf( bwb_ebuf, "in op_add(): str_cat() returns <%d>-byte string to level <%d>",
@@ -730,11 +750,7 @@ op_assign( level, precision )
 
       case NUMBER:
          * var_findnval( CURTASK exps[ level - 1 ].xvar, 
-#ifdef OLDWAY
-	    CURTASK exps[ level - 1 ].xvar->array_pos )  =
-#else
-	    CURTASK exps[ level - 1 ].array_pos )  =
-#endif
+            CURTASK exps[ level - 1 ].array_pos ) =
             CURTASK exps[ level - 1 ].nval = 
             exp_getnval( &( CURTASK exps[ level + 1 ] ) );
          break;
@@ -1522,7 +1538,7 @@ op_intdiv( level, precision )
 	FUNCTION:       op_or()
 
 	DESCRIPTION:    This function compares two integers and
-			performs a logical NOT on them.
+			performs a logical OR on them.
 
 ***************************************************************/
 
@@ -1579,7 +1595,7 @@ op_or( level, precision )
 	FUNCTION:       op_and()
 
 	DESCRIPTION:    This function compares two integers and
-			performs a logical NOT on them.
+			performs a logical AND on them.
 
 ***************************************************************/
 
@@ -1636,8 +1652,8 @@ op_and( level, precision )
 
 	FUNCTION:       op_not()
 
-	DESCRIPTION:    This function compares two integers and
-			performs a logical NOT on them.
+	DESCRIPTION:    This function performs a logical NOT on
+			the integer to the right.
 
 ***************************************************************/
 
@@ -1682,7 +1698,7 @@ op_not( level, precision )
 
 #if INTENSIVE_DEBUG
          sprintf( bwb_ebuf, "in op_not(): result is <%d>, precision <%c>",
-            (int) r, precision );
+            (unsigned int) exp_getnval( &( CURTASK exps[ level ] )), precision );
          bwb_debug( bwb_ebuf );
 #endif
 
@@ -1713,7 +1729,7 @@ op_not( level, precision )
 	FUNCTION:       op_xor()
 
 	DESCRIPTION:    This function compares two integers and
-			performs a logical NOT on them.
+			performs a logical XOR on them.
 
 ***************************************************************/
 
@@ -1767,6 +1783,83 @@ op_xor( level, precision )
 
 /***************************************************************
 
+	FUNCTION:       op_negation()
+
+	DESCRIPTION:    This function performs a negation on the
+			element to the right.
+			Added by JBV 10/95
+
+***************************************************************/
+
+#if ANSI_C
+static int
+op_negation( int level, int precision )
+#else
+static int
+op_negation( level, precision )
+   int level;
+   int precision;
+#endif
+   {
+
+   switch( precision )
+      {
+      case STRING:
+
+
+         /* both sides of the operation should be numbers for
+            logical comparison; if not, report an error */
+
+#if PROG_ERRORS
+         sprintf( bwb_ebuf, "Strings cannot be compared logically." );
+         bwb_error( bwb_ebuf );
+#else
+         bwb_error( err_mismatch );
+#endif
+
+         break;
+
+      default:
+
+#if INTENSIVE_DEBUG
+         sprintf( bwb_ebuf, "in op_negation(): argument is <%f>, precision <%c>",
+            exp_getnval( &( CURTASK exps[ level + 1 ] )), precision );
+         bwb_debug( bwb_ebuf );
+#endif
+
+         CURTASK exps[ level ].nval = (bnumber)
+            -( exp_getnval( &( CURTASK exps[ level + 1 ] )) );
+
+#if INTENSIVE_DEBUG
+         sprintf( bwb_ebuf, "in op_negation(): result is <%f>, precision <%c>",
+            exp_getnval( &( CURTASK exps[ level ] )), precision );
+         bwb_debug( bwb_ebuf );
+#endif
+
+         break;
+      }
+
+   /* set variable type to requested precision (JBV) */
+
+   CURTASK exps[ level ].type = (char) precision;
+   CURTASK exps[ level ].operation = NUMBER;
+
+   /* decrement the stack once */
+
+   op_pulldown( 1 );
+
+#if INTENSIVE_DEBUG
+   sprintf( bwb_ebuf, "in op_negation(): CURTASK expsc <%d>, level <%d> result <%f>",
+      CURTASK expsc, level, CURTASK exps[ CURTASK expsc ].nval );
+   bwb_debug( bwb_ebuf );
+#endif
+
+   return TRUE;
+
+   }
+
+/***************************************************************
+
 	FUNCTION:       op_islevelstr()
 
 	DESCRIPTION:    This function determines whether the
@@ -1903,8 +1996,18 @@ op_pulldown( how_far )
    while ( CURTASK expsc >= ( level + how_far ) )
       {
 
+      /*------------------------------------------------------*/
+      /* But before memcpy, deallocate sbuffer for level, and */
+      /* afterwards, set sbuffer for level + how_far to NULL! */
+      /* Else konfusion reigns the next time around... (JBV)  */
+      /*------------------------------------------------------*/
+
+      if( CURTASK exps[ level ].sval.sbuffer != NULL ) /* JBV */
+         FREE( CURTASK exps[ level ].sval.sbuffer, "op_pulldown" );
       memcpy( &CURTASK exps[ level ], &CURTASK exps[ level + how_far ],
          (size_t) ( sizeof( struct exp_ese )) );
+      CURTASK exps[ level + how_far ].sval.sbuffer = NULL; /* JBV */
+
       ++level;
 
       }
diff --git a/bwb_par.c b/bwb_par.c
index db05e98..38e0a5f 100644
--- a/bwb_par.c
+++ b/bwb_par.c
@@ -25,6 +25,11 @@
 
 ***************************************************************/
 
+/*---------------------------------------------------------------*/
+/* NOTE: Modifications marked "JBV" were made by Jon B. Volkoff, */
+/* 11/1995 (eidetics@cerf.net).                                  */
+/*---------------------------------------------------------------*/
+
 #include <stdio.h>
 
 #include "bwbasic.h"
@@ -69,7 +74,8 @@ bwb_newtask( task_requested )
 
    /* get memory for task structure */
 
-   if ( ( bwb_tasks[ task_requested ] = calloc( 1, sizeof( struct bwb_task ) ) )
+   /* Revised to CALLOC pass-thru call by JBV */
+   if ( ( bwb_tasks[ task_requested ] = CALLOC( 1, sizeof( struct bwb_task ), "bwb_newtask" ) )
       == NULL )
       {
 #if PROG_ERRORS
@@ -107,4 +113,3 @@ bwb_newtask( task_requested )
 #endif
 
 
-
\ No newline at end of file
diff --git a/bwb_prn.c b/bwb_prn.c
index baf0377..5085b0a 100644
--- a/bwb_prn.c
+++ b/bwb_prn.c
@@ -23,6 +23,11 @@
 
 ***************************************************************/
 
+/*---------------------------------------------------------------*/
+/* NOTE: Modifications marked "JBV" were made by Jon B. Volkoff, */
+/* 11/1995 (eidetics@cerf.net).                                  */
+/*---------------------------------------------------------------*/
+
 #include <stdio.h>
 #include <ctype.h>
 #include <math.h>
@@ -103,7 +108,9 @@ bwb_print( l )
    if ( init == FALSE )
       {
       init = TRUE;
-      if ( ( s_buffer = calloc( MAXSTRINGSIZE + 1, sizeof(char) ) ) == NULL )
+
+      /* Revised to CALLOC pass-thru call by JBV */
+      if ( ( s_buffer = CALLOC( MAXSTRINGSIZE + 1, sizeof(char), "bwb_print") ) == NULL )
          {
 #if PROG_ERRORS
          bwb_error( "in bwb_print(): failed to get memory for s_buffer" );
@@ -232,6 +239,9 @@ bwb_xprint( l, f )
    static char *element;
    static char *prnbuf;
    static int init = FALSE;
+   register int i, j; /* JBV */
+   int dig_pos, dec_pos; /* JBV */
+   char tbuf[ MAXSTRINGSIZE + 1 ]; /* JBV */
 #if INTENSIVE_DEBUG || TEST_BSTRING
    bstring *b;
 #endif
@@ -241,7 +251,9 @@ bwb_xprint( l, f )
    if ( init == FALSE )
       {
       init = TRUE;
-      if ( ( format_string = calloc( MAXSTRINGSIZE + 1, sizeof(char) ) ) == NULL )
+
+      /* Revised to CALLOC pass-thru call by JBV */
+      if ( ( format_string = CALLOC( MAXSTRINGSIZE + 1, sizeof(char), "bwb_xprint") ) == NULL )
          {
 #if PROG_ERRORS
          bwb_error( "in bwb_xprint(): failed to get memory for format_string" );
@@ -249,7 +261,8 @@ bwb_xprint( l, f )
          bwb_error( err_getmem );
 #endif
          }
-      if ( ( output_string = calloc( MAXSTRINGSIZE + 1, sizeof(char) ) ) == NULL )
+      /* Revised to CALLOC pass-thru call by JBV */
+      if ( ( output_string = CALLOC( MAXSTRINGSIZE + 1, sizeof(char), "bwb_xprint") ) == NULL )
          {
 #if PROG_ERRORS
          bwb_error( "in bwb_xprint(): failed to get memory for output_string" );
@@ -257,7 +270,8 @@ bwb_xprint( l, f )
          bwb_error( err_getmem );
 #endif
          }
-      if ( ( element = calloc( MAXSTRINGSIZE + 1, sizeof(char) ) ) == NULL )
+      /* Revised to CALLOC pass-thru call by JBV */
+      if ( ( element = CALLOC( MAXSTRINGSIZE + 1, sizeof(char), "bwb_xprint") ) == NULL )
          {
 #if PROG_ERRORS
          bwb_error( "in bwb_xprint(): failed to get memory for element buffer" );
@@ -265,7 +279,8 @@ bwb_xprint( l, f )
          bwb_error( err_getmem );
 #endif
          }
-      if ( ( prnbuf = calloc( MAXSTRINGSIZE + 1, sizeof(char) ) ) == NULL )
+      /* Revised to CALLOC pass-thru call by JBV */
+      if ( ( prnbuf = CALLOC( MAXSTRINGSIZE + 1, sizeof(char), "bwb_xprint") ) == NULL )
          {
 #if PROG_ERRORS
          bwb_error( "in bwb_xprint(): failed to get memory for prnbuf" );
@@ -425,8 +440,9 @@ bwb_xprint( l, f )
                   bwb_error( err_mismatch );
 #endif
                   }
-               sprintf( output_string, "%.*s", format->width,
-                  element );
+               if ( format->width == -1 ) /* JBV */
+                  sprintf( output_string, "%s", element );
+               else sprintf( output_string, "%.*s", format->width, element );
 
 #if INTENSIVE_DEBUG
                sprintf( bwb_ebuf, "in bwb_xprint(): output string <%s>",
@@ -434,7 +450,7 @@ bwb_xprint( l, f )
                bwb_debug( bwb_ebuf );
 #endif
 
-               prn_xprintf( f, output_string );
+               prn_xxprintf( f, output_string ); /* Was prn_xprintf (JBV) */
                break;
 
 	    case NUMBER:
@@ -449,22 +465,116 @@ bwb_xprint( l, f )
 
 	       if ( format->exponential == TRUE )
 		  {
-		  sprintf( output_string, "%e",
-		     exp_getnval( e ) );
+                  /*------------------------------------------------------*/
+                  /* NOTE: Width and fill have no effect on C exponential */
+                  /* format (JBV)                                         */
+                  /*------------------------------------------------------*/
+		  if ( format->sign == TRUE ) /* Added by JBV */
+                     sprintf( output_string, "%+e", exp_getnval( e ) );
+		  else
+                     sprintf( output_string, "%e", exp_getnval( e ) );
 		  }
 	       else
 		  {
+                  /*---------------------------------------------------*/
+                  /* NOTE: Minus, commas, and money are only valid for */
+                  /* floating point format (JBV)                       */
+                  /*---------------------------------------------------*/
+		  if ( format->sign == TRUE ) /* Added by JBV */
+		  sprintf( output_string, "%+*.*f",
+		     format->width, format->precision, exp_getnval( e ) );
+		  else if ( format->minus == TRUE ) /* Added by JBV */
+                  {
+		      sprintf( output_string, "%*.*f",
+		         format->width, format->precision, exp_getnval( e ) );
+                      for (i = 0; i < strlen( output_string ); ++i )
+                      {
+                          if ( output_string[ i ] != ' ' )
+                          {
+                              if ( output_string[ i ] == '-' )
+                              {
+                                  output_string[ i ] = ' ';
+                                  strcat( output_string, "-" );
+                              }
+                              else strcat( output_string, " " );
+                              break;
+                          }
+                      }
+                  }
+		  else
 		  sprintf( output_string, "%*.*f",
 		     format->width, format->precision, exp_getnval( e ) );
+
+                  if ( format->commas == TRUE ) /* Added by JBV */
+                  {
+                      dig_pos = -1;
+                      dec_pos = -1;
+                      for ( i = 0; i < strlen( output_string ); ++i )
+                      {
+                          if ( ( isdigit( output_string[ i ] ) != 0 )
+                          && ( dig_pos == -1 ) )
+                             dig_pos = i;
+                          if ( ( output_string[ i ] == '.' )
+                          && ( dec_pos == -1 ) )
+                             dec_pos = i;
+                          if ( ( dig_pos != -1 ) && ( dec_pos != -1 ) ) break;
+                      }
+                      if ( dec_pos == -1 ) dec_pos = strlen( output_string );
+                      j = 0;
+                      for ( i = 0; i < strlen( output_string ); ++i )
+                      {
+                          if ( ( ( dec_pos - i ) % 3 == 0 )
+                          && ( i > dig_pos ) && ( i < dec_pos ) )
+                          {
+                              tbuf[ j ] = ',';
+                              ++j;
+                              tbuf[ j ] = '\0';
+                          }
+                          tbuf[ j ] = output_string[ i ];
+                          ++j;
+                          tbuf[ j ] = '\0';
+                      }
+                      strcpy( output_string,
+                         &tbuf[ strlen( tbuf ) - strlen( output_string ) ] );
+                  }
+
+                  if ( format->money == TRUE ) /* Added by JBV */
+                  {
+                      for ( i = 0; i < strlen( output_string ); ++i )
+                      {
+                          if ( output_string[ i ] != ' ' )
+                          {
+                              if ( i > 0 )
+                              {
+                                  if ( isdigit( output_string[ i ] ) == 0 )
+                                  {
+                                      output_string[ i - 1 ]
+                                         = output_string[ i ];
+                                      output_string[ i ] = '$';
+                                  }
+                                  else output_string[ i - 1 ] = '$';
+                              }
+                              break;
+                          }
+                      }
+                  }
+
 		  }
 
+                  if ( format->fill == '*' ) /* Added by JBV */
+                  for ( i = 0; i < strlen( output_string ); ++i )
+                  {
+                     if ( output_string[ i ] != ' ' ) break;
+                     output_string[ i ] = '*';
+                  }
+
 #if INTENSIVE_DEBUG
 	       sprintf( bwb_ebuf, "in bwb_xprint(): output number <%f> string <%s>",
 		  exp_getnval( e ), output_string );
 	       bwb_debug( bwb_ebuf );
 #endif
 
-               prn_xprintf( f, output_string );
+               prn_xxprintf( f, output_string ); /* Was prn_xprintf (JBV) */
                break;
 
 	    default:
@@ -521,7 +631,9 @@ bwb_xprint( l, f )
             break;
 #endif
          case ',':		/* tab over */
-            xputc( f, '\t' );
+            /* Tab only if there's no format specification! (JBV) */
+            if (( fs_pos == -1 ) || ( strlen( element ) == 0 ))
+               xputc( f, '\t' );
             ++l->position;
             adv_ws( l->buffer, &( l->position ) );
             break;
@@ -536,6 +648,9 @@ bwb_xprint( l, f )
 
       }				/* end of loop through print elements */
 
+   if (( fs_pos > -1 ) && ( strlen( element ) > 0 ))
+      format = get_prnfmt( format_string, &fs_pos, f ); /* Finish up (JBV) */
+
    /* call prn_cr() to print a CR if it is not overridden by a
       concluding ';' mark */
 
@@ -593,7 +708,7 @@ get_prnfmt( buffer, position, f )
 
    /* advance past whitespace */
 
-   adv_ws( buffer, position );
+   /* adv_ws( buffer, position ); */  /* Don't think we want this (JBV) */
 
    /* check first character: a lost can be decided right here */
 
@@ -610,7 +725,9 @@ get_prnfmt( buffer, position, f )
       switch( buffer[ *position ] )
          {
          case ' ':		/* end of this format segment */
-            loop = FALSE;
+            xxputc( f, buffer[ *position ] ); /* Gotta output it (JBV) */
+            ++( *position ); /* JBV */
+            if (retstruct.type != FALSE) loop = FALSE; /* JBV */
             break;
          case '\0':		/* end of format string */
          case '\n':
@@ -619,13 +736,20 @@ get_prnfmt( buffer, position, f )
             return &retstruct;
          case '_':		/* print next character as literal */
             ++( *position );
-            xputc( f, buffer[ *position ] );
+            xxputc( f, buffer[ *position ] ); /* Not xputc, no tabs (JBV) */
             ++( *position );
             break;
 
 	 case '!':
             retstruct.type = STRING;
             retstruct.width = 1;
+            ++( *position ); /* JBV */
+            return &retstruct;
+
+	 case '&': /* JBV */
+            retstruct.type = STRING;
+            retstruct.width = -1; 
+            ++( *position );
             return &retstruct;
 
 	 case '\\':
@@ -649,18 +773,22 @@ get_prnfmt( buffer, position, f )
                }
             return &retstruct;
          case '$':
+            ++retstruct.width; /* JBV */
             ++( *position );
             retstruct.money = TRUE;
             if ( buffer[ *position ] == '$' )
                {
+               ++retstruct.width; /* JBV */
                ++( *position );
                }
             break;
          case '*':
+            ++retstruct.width; /* JBV */
             ++( *position );
             retstruct.fill = '*';
             if ( buffer[ *position ] == '*' )
                {
+               ++retstruct.width; /* JBV */
                ++( *position );
                }
             break;
@@ -670,14 +798,17 @@ get_prnfmt( buffer, position, f )
             break;
          case '#':
             retstruct.type = NUMBER;		/* for now */
-            ++( *position );
-            for ( retstruct.width = 1; buffer[ *position ] == '#'; ++( *position ) )
+            /* ++( *position ); */  /* Removed by JBV */
+            /* The initial condition shouldn't be retstruct.width = 1 (JBV) */
+            for ( ; buffer[ *position ] == '#'; ++( *position ) )
                {
                ++retstruct.width;
                }
             if ( buffer[ *position ] == ',' )
                {
                retstruct.commas = TRUE;
+               ++retstruct.width; /* JBV */
+               ++( *position ); /* JBV */
                }
             if ( buffer[ *position ] == '.' )
                {
@@ -706,6 +837,11 @@ get_prnfmt( buffer, position, f )
                }
             return &retstruct;
 
+	 default: /* JBV */
+            xxputc( f, buffer[ *position ] ); /* Gotta output it (JBV) */
+            ++( *position );
+            break;
+
          }
       }					/* end of loop */
 
@@ -838,6 +974,42 @@ prn_xprintf( f, buffer )
 
 /***************************************************************
 
+        FUNCTION:       prn_xxprintf()
+
+	DESCRIPTION:    This function outputs a null-terminated
+			string to a specified file or output
+			device without expanding tabs.
+			Added by JBV 10/95
+
+***************************************************************/
+
+#if ANSI_C
+int
+prn_xxprintf( FILE *f, char *buffer )
+#else
+int
+prn_xxprintf( f, buffer )
+   FILE *f;
+   char *buffer;
+#endif
+   {
+   char *p;
+
+   /* DO NOT try anything so stupid as to run bwb_debug() from
+      here, because it will create an endless loop. And don't
+      ask how I know. */
+
+   for ( p = buffer; *p != '\0'; ++p )
+      {
+      xxputc( f, *p );
+      }
+
+   return TRUE;
+
+   }
+
+/***************************************************************
+
         FUNCTION:       xputc()
 
 	DESCRIPTION:    This function outputs a character to a
@@ -1111,11 +1283,11 @@ prn_precision( v )
 
 #if INTENSIVE_DEBUG
       sprintf( bwb_ebuf, "in prn_precision(): fmod( %f, %f ) = %.12f",
-         nval, d, fmod( nval, d ) );
+         nval, d, fmod( (double) nval, (double) d ) );
       bwb_debug( bwb_ebuf );
 #endif
 
-      if ( fmod( nval, d ) < 0.0000001 )
+      if ( fmod( (double) nval, (double) d ) < 0.0000001 ) /* JBV */
          {
          return r;
          }
@@ -1187,6 +1359,8 @@ bwb_lerror( l )
    {
    char tbuf[ MAXSTRINGSIZE + 1 ];
    int n;
+   struct exp_ese *e; /* JBV */
+   int pos; /* JBV */
 
 #if INTENSIVE_DEBUG
    sprintf( bwb_ebuf, "in bwb_lerror(): entered function " );
@@ -1211,7 +1385,12 @@ bwb_lerror( l )
    /* get the variable name or numerical constant */
 
    adv_element( l->buffer, &( l->position ), tbuf );
-   n = atoi( tbuf );
+   /* n = atoi( tbuf ); */  /* Removed by JBV */
+
+   /* Added by JBV */
+   pos = 0;
+   e = bwb_exp( tbuf, FALSE, &pos );
+   n = (int) exp_getnval( e );
 
 #if INTENSIVE_DEBUG
    sprintf( bwb_ebuf, "in bwb_lerror(): error number is <%d> ", n );
diff --git a/bwb_stc.c b/bwb_stc.c
index eaf7482..96c6bed 100644
--- a/bwb_stc.c
+++ b/bwb_stc.c
@@ -29,6 +29,11 @@
 
 ***************************************************************/
 
+/*---------------------------------------------------------------*/
+/* NOTE: Modifications marked "JBV" were made by Jon B. Volkoff, */
+/* 11/1995 (eidetics@cerf.net).                                  */
+/*---------------------------------------------------------------*/
+
 #include <stdio.h>
 #include <ctype.h>
 
@@ -184,12 +189,22 @@ fslt_clear()
       while ( c != NULL )
          {
          n = c->next;
-         free( c );
+
+         /* Revised to FREE pass-thru call by JBV */
+         FREE( c, "fslt_clear" );
          c = n;
          }
 
       next = current->next;
-      free( current );
+
+      /* Revised to FREE pass-thru calls by JBV */
+      if (current->name != NULL)
+      {
+          FREE( current->name, "fslt_clear" ); /* JBV */
+          current->name = NULL; /* JBV */
+      }
+      FREE( current, "fslt_clear" );
+      current = NULL; /* JBV */
       }
 
    /* reset linkage */
@@ -360,6 +375,18 @@ scan_element( buffer, pos, element )
                }
             break;
 
+         case '(':                     /* MID$ command termination (JBV) */
+            /* If MID$ is here, get out */
+            if (strcmp(element, CMD_MID) == 0)
+               return TRUE;
+
+            /* else add it to the accumulation element */
+            element[ e_pos ] = buffer[ *pos ];
+            ++e_pos;
+            ++( *pos );
+            element[ e_pos ] = '\0';
+            break;
+
          default:
             element[ e_pos ] = buffer[ *pos ];
             ++e_pos;
@@ -428,7 +455,8 @@ fslt_add( line, position, code )
 
    /* get memory for name buffer */
 
-   if ( ( name = calloc( 1, strlen( tbuf ) + 1 ) ) == NULL )
+   /* Revised to CALLOC pass-thru call by JBV */
+   if ( ( name = CALLOC( 1, strlen( tbuf ) + 1, "fslt_add" ) ) == NULL )
       {
 #if PROG_ERRORS
       bwb_error( "in fslt_add(): failed to get memory for name buffer" );
@@ -442,7 +470,7 @@ fslt_add( line, position, code )
 
    /* get memory for fslt structure */
 
-   if ( ( f = calloc( 1, sizeof( struct fslte ) ) ) == NULL )
+   if ( ( f = CALLOC( 1, sizeof( struct fslte ), "fslt_add" ) ) == NULL )
       {
 #if PROG_ERRORS
       bwb_error( "in fslt_add(): failed to get memory for fslt structure" );
@@ -1898,7 +1926,7 @@ var_pos( firstvar, p )
 	FUNCTION:       fslt_addcallvar()
 
 	DESCRIPTION:    This function adds a calling variable
-			to the FUNCTION-SUB lookuop table at
+			to the FUNCTION-SUB lookup table at
 			a specific level.
 
 ***************************************************************/
@@ -1932,7 +1960,7 @@ fslt_addcallvar( v )
 
 /***************************************************************
 
-	FUNCTION:       expufnc()
+	FUNCTION:       exp_ufnc()
 
         DESCRIPTION:	This C function interprets a user-defined
 			function, returning its value at the current
@@ -2158,7 +2186,7 @@ exp_ufnc( expression )
 	FUNCTION:       fslt_addlocalvar()
 
 	DESCRIPTION:    This function adds a local variable
-			to the FUNCTION-SUB lookuop table at
+			to the FUNCTION-SUB lookup table at
 			a specific level.
 
 ***************************************************************/
@@ -2275,4 +2303,3 @@ is_label( buffer )
    }
 
 
-
\ No newline at end of file
diff --git a/bwb_str.c b/bwb_str.c
index 7259d7c..4699b20 100644
--- a/bwb_str.c
+++ b/bwb_str.c
@@ -23,6 +23,11 @@
 
 ***************************************************************/
 
+/*---------------------------------------------------------------*/
+/* NOTE: Modifications marked "JBV" were made by Jon B. Volkoff, */
+/* 11/1995 (eidetics@cerf.net).                                  */
+/*---------------------------------------------------------------*/
+
 #include <stdio.h>
 
 #include "bwbasic.h"
@@ -64,7 +69,8 @@ str_btob( d, s )
 
    /* get memory for new buffer */
 
-   if ( ( t = (char *) calloc( s->length + 1, 1 )) == NULL )
+   /* Following section removed by JBV (no more mass string reallocation) */
+   /* if ( ( t = (char *) CALLOC( s->length + 1, 1, "str_btob" )) == NULL )
       {
 #if PROG_ERRORS
       bwb_error( "in str_btob(): failed to get memory for new buffer" );
@@ -72,14 +78,30 @@ str_btob( d, s )
       bwb_error( err_getmem );
 #endif
       return FALSE;
-      }
+      } */
 
-   /* write the c string to the b string */
+   /* Only one of these two conditions necessitates reallocation (JBV) */
+   if ( ( d->sbuffer == NULL ) || ( d->rab == TRUE ) )
+   {
+      if ( ( t = (char *) CALLOC( MAXSTRINGSIZE + 1, 1, "str_btob" )) == NULL )
+         {
+#if PROG_ERRORS
+         bwb_error( "in str_btob(): failed to get memory for new buffer" );
+#else
+         bwb_error( err_getmem );
+#endif
+         return FALSE;
+         }
+   }
+   else t = d->sbuffer; /* Leave well enough alone (JBV) */
+
+   /* write the b string to the temp c string */
 
    t[ 0 ] = '\0';
    for ( i = 0; i < (int) s->length; ++i )
       {
       t[ i ] = s->sbuffer[ i ];
+      t[ i + 1 ] = '\0'; /* JBV */
 #if INTENSIVE_DEBUG
       tbuf[ i ] = s->sbuffer[ i ];
       tbuf[ i + 1 ] = '\0';
@@ -96,18 +118,22 @@ str_btob( d, s )
       }
 #endif
 
-   if (( d->rab != TRUE ) && ( d->sbuffer != NULL ))
+   /* Following section removed by JBV (no more mass string reallocation) */
+   /* if (( d->rab != TRUE ) && ( d->sbuffer != NULL ))
       {
 #if INTENSIVE_DEBUG
       sprintf( tbuf, "in str_btob(): deallocating string memory" );
       bwb_debug ( tbuf );
 #endif
-      free( d->sbuffer );
+      FREE( d->sbuffer, "str_btob" );
+      d->sbuffer = NULL;
       }
    else
       {
       d->rab = (char) FALSE;
-      }
+      } */
+
+   d->rab = (char) FALSE; /* JBV */
 
    /* reassign buffer */
 
@@ -162,7 +188,21 @@ str_ctob( s, buffer )
 
    /* get memory for new buffer */
 
-   if ( ( t = (char *) calloc( strlen( buffer ) + 1, 1 )) == NULL )
+   /* Following section removed by JBV (no more mass string reallocation) */
+   /* if ( ( t = (char *) CALLOC( strlen( buffer ) + 1, 1, "str_ctob" )) == NULL )
+      {
+#if PROG_ERRORS
+      bwb_error( "in str_ctob(): failed to get memory for new buffer" );
+#else
+      bwb_error( err_getmem );
+#endif
+      return FALSE;
+      } */
+
+   /* Only one of these two conditions necessitates reallocation (JBV) */
+   if ( ( s->sbuffer == NULL ) || ( s->rab == TRUE ) )
+   {
+   if ( ( t = (char *) CALLOC( MAXSTRINGSIZE + 1, 1, "str_ctob" )) == NULL )
       {
 #if PROG_ERRORS
       bwb_error( "in str_ctob(): failed to get memory for new buffer" );
@@ -171,13 +211,16 @@ str_ctob( s, buffer )
 #endif
       return FALSE;
       }
+   }
+   else t = s->sbuffer; /* Leave well enough alone (JBV) */
 
-   /* write the c string to the b string */
+   /* write the c string to the temp c string */
 
    t[ 0 ] = '\0';
    for ( i = 0; i < (int) strlen( buffer ); ++i )
       {
       t[ i ] = buffer[ i ];
+      t[ i + 1 ] = '\0'; /* JBV */
 #if INTENSIVE_DEBUG
       tbuf[ i ] = buffer[ i ];
       tbuf[ i + 1 ] = '\0';
@@ -194,14 +237,18 @@ str_ctob( s, buffer )
       }
 #endif
 
-   if (( s->rab != TRUE ) && ( s->sbuffer != NULL ))
+   /* Following section removed by JBV (no more mass string reallocation) */
+   /* if (( s->rab != TRUE ) && ( s->sbuffer != NULL ))
       {
-      free( s->sbuffer );
+      FREE( s->sbuffer, "str_ctob" );
+      s->sbuffer = NULL;
       }
    else
       {
       s->rab = (char) FALSE;
-      }
+      } */
+
+   s->rab = (char) FALSE; /* JBV */
 
    /* reassign buffer */
 
@@ -351,5 +398,3 @@ str_cmp( a, b )
    }
 
 
-
-
\ No newline at end of file
